#include<bits/stdc++.h>
#define pb push_back
#define int long long
using namespace std;


signed main(){
	int n, m;
	cin >> n >> m;
	int a[n][m];
	int dp[n+1][m+1];
	for(int i=0; i< n; i++){
		for(int j=0; j < m; j++){
			cin >> a[i][j];
		}
	}
	int q;
	cin >> q;
	dp[0][0]=a[0][0];
	while(q--){
		int x, y;
		cin >> x >> y;
		x--; y--;
		int prev=a[x][y];
		a[x][y]=1e17;
		int ans=0;
		for(int i=1; i< m; i++){
			dp[0][i]=dp[0][i-1]+a[0][i];
		}
		for(int i=1; i< n; i++){
			dp[i][0]=dp[i-1][0]+a[i][0];
		}
		for(int i=1; i< n; i++){
			for(int j=1; j< m; j++){
				dp[i][j]=min(dp[i-1][j], dp[i][j-1])+a[i][j];
			}
		}
		cout << dp[n-1][m-1] << '\n';
		a[x][y]=prev;
	}
}